// file:signal_detector/src_00/sigd00_dbg_0.cc
//

// isip include files
//
#include "signal_detector_00.h"
#include "signal_detector_00_constants.h"

// method: debug_cc
//
// arguments:
//  FILE* fp_p: (input) file pointer to output the debug information to
//  char_1* message_p: (input) a message to be concatenated to each debug
//			       message
//
// return:
//  a logical_1 indicating the status
//
logical_1 Signal_detector_00::debug_cc(FILE* fp_p, char_1* message_p) {

  // dump internal data
  //
  fprintf(fp_p, "%s: data format parameters:\n", message_p);
  fprintf(fp_p, "%s:  num_chan_d = %ld channels\n", message_p, num_chan_d);
  fprintf(fp_p, "%s:  sample_size_d = %ld bytes\n", message_p, sample_size_d);
  fprintf(fp_p, "%s:  chan_d = %ld channel\n", message_p, chan_d);

  fprintf(fp_p, "%s: signal processing parameters:\n", message_p);
  fprintf(fp_p, "%s:  sample_freq_d = %f Hz\n", message_p, sample_freq_d);
  fprintf(fp_p, "%s:  frame_dur_d = %f secs\n", message_p, frame_dur_d);
  fprintf(fp_p, "%s:  window_dur_d = %f secs\n", message_p, window_dur_d);
  fprintf(fp_p, "%s:  preemphasis_d = %f units\n", message_p, preemphasis_d);

  fprintf(fp_p, "%s: signal level-related parameters:\n", message_p);
  fprintf(fp_p, "%s:  nom_sig_lev_d = %f dB\n", message_p, nom_sig_lev_d);
  fprintf(fp_p, "%s:  sig_delta_d = %f dB\n", message_p, sig_delta_d);
  fprintf(fp_p, "%s:  sig_adapt_d = %f units\n", message_p, sig_adapt_d);

  fprintf(fp_p, "%s: noise level-related parameters:\n", message_p);
  fprintf(fp_p, "%s:  nom_noise_lev_d = %f dB\n", message_p, nom_noise_lev_d);
  fprintf(fp_p, "%s:  noise_delta_d = %f dB\n", message_p, noise_delta_d);
  fprintf(fp_p, "%s:  noise_adapt_d = %f units\n", message_p, noise_adapt_d);
  fprintf(fp_p, "%s:  noise_floor_d = %f dB\n", message_p, noise_floor_d);

  fprintf(fp_p, "%s: utterance duration parameters:\n", message_p);
  fprintf(fp_p, "%s:  utt_delta_d = %f dB\n", message_p, utt_delta_d);
  fprintf(fp_p, "%s:  min_utt_dur_d = %f secs\n", message_p, min_utt_dur_d);
  fprintf(fp_p, "%s:  min_utt_sep_d = %f secs\n", message_p, min_utt_sep_d);
  fprintf(fp_p, "%s:  max_utt_dur_d = %f secs\n", message_p, max_utt_dur_d);

  fprintf(fp_p, "%s: debug parameters:\n", message_p);  
  fprintf(fp_p, "%s:  debug_level_d = %ld\n", message_p, debug_level_d);


  // exit gracefully
  //
  return ISIP_TRUE;
}
