// file: signal_detector/src_00/sigd00_flush_0.cc
//

// isip include files
//

#include "signal_detector_00.h"
#include "signal_detector_00_constants.h"

// method: init_cc
//
// arguments: none
//
// return: logical_1
//
logical_1 Signal_detector_00::flush_cc() {
  
  // flush the system by processing i_min_utt_sep_d noise states
  //
  for (int_4 nf=0; nf<i_min_utt_sep_d; nf++) {
    
    // add a state
    int_4 cur_state = sm_advance_cc(noise_thresh_d);
    cb_add_cc(cur_state);
    
    // adjust circular buffer, smoothing out short bursts of frames
    // that fall below the signal threshold during an utterance
    // that don't meet the utterance duration constraints
    //
    cb_smooth_signal_cc();
    
    // adjust circular buffer, smoothing out short bursts of frames
    // that rise above the noise level that don't meet the utterance
    // constraints
    //
    cb_smooth_noise_cc();
    
    // do we have an utterance in progress?
    //  note that this call is made merely to make sure the flag is set
    //
    if (utt_in_progress_d == ISIP_FALSE)
      {utt_in_progress_d = cb_utt_in_progress_cc();}
    
    if (utt_in_progress_d == ISIP_TRUE) {
      
      // check for an utterance end
      //
      if (cb_utt_not_in_progress_cc() == ISIP_TRUE) {
	
	// clear utt in progress flag
	//
	utt_in_progress_d = ISIP_FALSE;
	
	// generate rough utterance endpoints
	//
	get_rough_endpoints_cc();

	// refine these endpoints
	//
	get_refined_endpoints_cc();

	// update rlse_frm_d
	//
	cb_release_cc(cur_frm_d);
      }
    }

    // update counters
    //
    nf_d++;
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}
