// file: /signal_detector/src_00/sigdp00_get_1.cc
//

// isip include files
//
#include "signal_detector_00.h"
#include "signal_detector_00_constants.h"

// method: get_refined_endpoints_cc
//
// arguments: none
//
// return:
//  a logical_1 value indicating status
//
logical_1 Signal_detector_00::get_refined_endpoints_cc() {

  // scan from the beginning of utterance backwards to the first NOIS state
  //
  while (cb_d[utt_beg_cb_indx_d] != SIGD_STATE_NOIS)
    {utt_beg_cb_indx_d = cb_increment_cc(utt_beg_cb_indx_d, (int_4)-1);}

  // scan from the end of an utterance forward to the first NOIS state
  utt_end_cb_indx_d = cb_increment_cc(utt_beg_cb_indx_d, (int_4)1);
  while (cb_d[utt_end_cb_indx_d] != SIGD_STATE_NOIS)
    {utt_end_cb_indx_d = cb_increment_cc(utt_end_cb_indx_d, (int_4)1);}

  // convert from a circular buffer index to the real frame number
  //
  utt_beg_d = nf_d - (cb_diff_cc(cur_frm_d, utt_beg_cb_indx_d));
  utt_end_d = nf_d - (cb_diff_cc(cur_frm_d, utt_end_cb_indx_d));

  // exit gracefully
  //
  return ISIP_TRUE;
}
