// file: project/integrate/src_00/sigdp00_ip_0.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "signal_detector_00.h"
#include "signal_detector_00_constants.h"

// method: interpret_param_cc
//
// arguments:
//  char_1* name_p: (input) parameter name
//  float_4& val_p: (output) parameter value
//
// return:
//  a logical_1 value if the parameter name has been found
//
// this method assigns a value to a parameter
//
logical_1 Signal_detector_00::interpret_parameter_cc(char_1* name_p,
						  float_4& val_p) {

  // check algorithm being used
  //
   if (strcmp((char*)name_p, "algorithm") == (int)0){
   algorithm = (float_4)val_p;}   

   //
   // check data format parameters
   else if (strcmp((char*)name_p, "number_of_channels") == (int)0)
     {num_chan_d = (int_4)val_p;}
   else if (strcmp((char*)name_p, "sample_size") == (int)0)
     {sample_size_d = (int_4)val_p;}
   else if (strcmp((char*)name_p, "channel_to_be_processed") == (int)0)
     {chan_d = (int_4)val_p;}
   
  // check signal processing parameters
  //
   else if (strcmp((char*)name_p, "sample_frequency") == (int)0)
    {sample_freq_d = val_p;}
   else if (strcmp((char*)name_p, "frame_duration") == (int)0)
     {frame_dur_d = val_p;}
   else if (strcmp((char*)name_p, "window_duration") == (int)0)
     {window_dur_d = val_p;}
   else if (strcmp((char*)name_p, "preemphasis") == (int)0)
     {preemphasis_d = val_p;}
   
   // check signal-level related parameters
   //
   else if (strcmp((char*)name_p, "nominal_signal_level") == (int)0)
     {nom_sig_lev_d = val_p;}
   else if (strcmp((char*)name_p, "signal_adaptation_delta") == (int)0)
     {sig_delta_d = val_p;}
   else if (strcmp((char*)name_p, "signal_adaptation_constant") == (int)0)
     {sig_adapt_d = val_p;}
   
   // check noise-level related parameters
  //
   else if (strcmp((char*)name_p, "nominal_noise_level") == (int)0)
     {nom_noise_lev_d = val_p;}
   else if (strcmp((char*)name_p, "noise_adaptation_delta") == (int)0)
     {noise_delta_d = val_p;}
   else if (strcmp((char*)name_p, "noise_adaptation_constant") == (int)0)
     {noise_adapt_d = val_p;}
  else if (strcmp((char*)name_p, "noise_floor") == (int)0)
    {noise_floor_d = val_p;}
   
   // check utterance duration parameters
  //
  else if (strcmp((char*)name_p, "utterance_delta") == (int)0)
    {utt_delta_d = val_p;}
  else if (strcmp((char*)name_p, "minimum_utterance_duration") == (int)0)
    {min_utt_dur_d = val_p;}
  else if (strcmp((char*)name_p, "minimum_utterance_separation") == (int)0)
    {min_utt_sep_d = val_p;}
  else if (strcmp((char*)name_p, "maximum_utterance_duration") == (int)0)
    {max_utt_dur_d = val_p;}
  
  // check for a debug parameter
  //
  else if (strcmp((char*)name_p, "debug_level") == (int)0)
    {debug_level_d = (int_4)val_p;}
 
  // exit gracefully
  //
  
  return ISIP_TRUE;
}


