// file: project/integrate/src_00/sigdp00_str_0.cc
//

// system include files
//
#include <ctype.h>

// isip include files
//
#include "signal_detector_00.h"
#include "signal_detector_00_constants.h"

// method: string_length_cc
//
// arguments:
//  char_1* string_p: input string
//
// return:
//  an int_4 value containing the string length
//
// this method computes the number of non-white characters in a string
//
int_4 Signal_detector_00::string_length_cc(char_1* string_p) {

  // declare local variables
  //
  int_4 str_len = (int_4)0;

  // set the length
  //
  if (string_p == NULL)
    {return (int_4)0;}

  // loop over the entire string
  //
  while (*string_p != ISIP_NULL) {
    if (!isspace(*string_p))
      {str_len++;}
    string_p++;
  }

  // exit gracefully
  //
  return str_len;
}
