// file: signal_detector/src_00/sigdp00_upd_0.cc
//

// isip include files
//
#include "signal_detector_00.h"
#include "signal_detector_00_constants.h"

// method: update_thresholds_cc
//
// arguments:
//  float_4 egy_p: (input) energy in dB
//
// return:
//  a logical_1 value indicating the status
//
logical_1 Signal_detector_00::update_thresholds_cc(float_4 egy) {

  // declare local variables
  //

  // update the noise threshold
  //
  if (egy > noise_floor_d) {
    if (egy < (nom_noise_lev_d+noise_delta_d)) {
      noise_thresh_d = noise_adapt_d * noise_thresh_d +
	(1.0 - noise_adapt_d) * egy;
    }
  }

  // update the signal threshold
  //
  if (egy > (nom_sig_lev_d-sig_delta_d)) {
    sig_thresh_d = sig_adapt_d * sig_thresh_d +
      (1.0 - sig_adapt_d) * egy;
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}
