// file: project/integrate/src_01/sigd01_load_0.cc
//

// isip include files
//
#include "signal_detector_01.h"
#include "signal_detector_01_constants.h"

// method: load_parameters_cc
//
// arguments:
//  char_1* param_file_p: algorithm parameter filename
//
// return:
//  a logical_1 value indicating status
//
// this method loads algorithm parameters
//
logical_1 Signal_detector_01::load_parameters_cc(char_1* param_file_P)
 {

  // declare local variables
  //
  char_1 line_buf[SIGD_MAX_STRING_LENGTH];
  char_1 param_name[SIGD_MAX_STRING_LENGTH];
  logical_1 flag_whitespace;
  float_4 param_val;

  // open a file
  //
  FILE* fp = fopen((char*)param_file_P, "r");
  if (fp == NULL) {
    printf("%s\n","load_parameters_cc:can't open input file");
  }

  // loop over all lines
  //
  while (fgets((char*)line_buf, SIGD_MAX_STRING_LENGTH-1, fp) != NULL) {

    // check for whitespace or a comment
    //
    if ((line_buf[0] == SIGD_COMMENT_CHAR) ||
	(string_length_cc(line_buf) == (int_4)0)) {
      flag_whitespace = ISIP_TRUE;
    }
    else
      {flag_whitespace = ISIP_FALSE;}

    // parse the line
    //
    if (flag_whitespace == ISIP_FALSE) {
      sscanf((char*)line_buf, "%s%*s%f%*s", (char*)param_name, &param_val);

      // interpret the parameter
      // 
     
      if (interpret_parameter_cc(param_name, param_val) == ISIP_FALSE) {
       printf("%s\n","load_parameters_cc:invalid parameter name");
     }
    }
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
