// file: project/integrate/src_01/sigd01_print_0.cc
//

// isip include files
//
#include "signal_detector_01.h"
#include "signal_detector_01_constants.h"

// method: debug_cc
//
// arguments:
//  char_1* outfile_p: (input) file pointer to output the parameter values
//
// return:
//  a logical_1 indicating the status
//
logical_1 Signal_detector_01::print_parameters_cc(char_1* outfile_p) {
  
  //open the file for dumping algorithm specific parameter values
  //
  FILE* fp_p = fopen((char*)outfile_p,"w");
 
  // dump internal data
  //
  fprintf(fp_p, "  data format parameters:\n");
  fprintf(fp_p, "  num_chan_d = %ld channels\n", num_chan_d);
  fprintf(fp_p, "  sample_size_d = %ld bytes\n", sample_size_d);
  fprintf(fp_p, "  chan_d = %ld channel\n", chan_d);

  fprintf(fp_p, " signal processing parameters:\n");
  fprintf(fp_p, "  sample_freq_d = %f Hz\n", sample_freq_d);
  fprintf(fp_p, "  frame_dur_d = %f secs\n", frame_dur_d);
  fprintf(fp_p, "  window_dur_d = %f secs\n", window_dur_d);
  fprintf(fp_p, "  preemphasis_d = %f units\n", preemphasis_d);

  fprintf(fp_p, " signal level-related parameters:\n");
  fprintf(fp_p, "  nom_sig_lev_d = %f dB\n", nom_sig_lev_d);
  fprintf(fp_p, "  sig_delta_d = %f dB\n", sig_delta_d);
  fprintf(fp_p, "  sig_adapt_d = %f units\n", sig_adapt_d);

  fprintf(fp_p, " noise level-related parameters:\n");
  fprintf(fp_p, " nom_noise_lev_d = %f dB\n", nom_noise_lev_d);
  fprintf(fp_p, "  noise_delta_d = %f dB\n", noise_delta_d);
  fprintf(fp_p, "  noise_adapt_d = %f units\n", noise_adapt_d);
  fprintf(fp_p, "  noise_floor_d = %f dB\n", noise_floor_d);

  fprintf(fp_p, " utterance duration parameters:\n");
  fprintf(fp_p, "  utt_delta_d = %f dB\n", utt_delta_d);
  fprintf(fp_p, "  min_utt_dur_d = %f secs\n", min_utt_dur_d);
  fprintf(fp_p, "  min_utt_sep_d = %f secs\n", min_utt_sep_d);
  fprintf(fp_p, "  max_utt_dur_d = %f secs\n", max_utt_dur_d);

  fprintf(fp_p, " debug parameters:\n");
  fprintf(fp_p, " debug_level_d = %ld\n", debug_level_d);

 // exit gracefully
 //
  return ISIP_TRUE;
}

