// file: /signal_detector/src_01/sigdp01_cb_0.cc
//

// isip include files
//
#include "signal_detector_01.h"
#include "signal_detector_01_constants.h"

// method: cb_increment_cc
//
// arguments:
//  int_4 index_p: (input) index to be incremented
//			   (usually cur_frm or rlse_frm)
//  int_4 incr_p: (input) number of frames to increment the index
//		          the sign determines the direction
//
// return:
//  an int_4 value containing the current position in the buffer
//
int_4 Signal_detector_01::cb_increment_cc(int_4 index_p, int_4 incr_p) {

  // increment the counter
  //
  index_p += incr_p;

  // check for wraparound past the end of the buffer
  //
  while (index_p >= cb_len_d)
    {index_p = index_p - cb_len_d;}

  // check for wraparound past the beginning of the buffer
  //
  while (index_p < (int_4)0)
    {index_p = cb_len_d + index_p;}

  // exit gracefully
  //
  return index_p;
}
