//file:signal_detector/src_01/sigdp01_cb_7.cc
//

// isip include files
//
#include "signal_detector_01.h"
#include "signal_detector_01_constants.h"

// method: cb_utt_not_in_progress_cc
//
// arguments: none
//
// return:
//  a logical_1 indicating whether we have a noise state
//
// this method is normally called after an utterance has been in progress
// to determine when the end of utterance has occurred.
//
logical_1 Signal_detector_01::cb_utt_not_in_progress_cc() {

  // make sure the buffer is full
  //
  if (cb_diff_cc(cur_frm_d, rlse_frm_d) < i_min_utt_sep_d)
    {return ISIP_FALSE;}

  // seek backwards from cur_frm to rlse_frm looking for a run of states
  // equal to NOIS
  //
  int_4 nf = cur_frm_d;

  for (int_4 counter=0; counter<i_min_utt_sep_d; counter++) {

    // check the current frame
    //
    if (cb_d[nf] != SIGD_STATE_NOIS)
      {return ISIP_FALSE;}

    // decrement the counter
    //
    nf = cb_increment_cc(nf, (int_4)-1);
  }

  // exit gracefully - the signal is in the NOIS state
  //
  return ISIP_TRUE;
}
