// file: signal_detector/src_01/sigdp01_get_0.cc
//

// isip include files
//
#include "signal_detector_01.h"
#include "signal_detector_01_constants.h"

// method: get_rough_endpoints_cc
//
// arguments: none
//
// return:
//  a logical_1 value indicating whether a set of valid endpoints have
//  been found
//
logical_1 Signal_detector_01::get_rough_endpoints_cc() {

  // scan for the start of an utterance
  //
  utt_beg_cb_indx_d = rlse_frm_d;
  while (cb_d[utt_beg_cb_indx_d] != SIGD_STATE_SIGN)
    {utt_beg_cb_indx_d = cb_increment_cc(utt_beg_cb_indx_d, (int_4)1);}

  // scan for the end of an utterance
  utt_end_cb_indx_d = cb_increment_cc(utt_beg_cb_indx_d, (int_4)1);
  while (cb_d[utt_end_cb_indx_d] == SIGD_STATE_SIGN)
    {utt_end_cb_indx_d = cb_increment_cc(utt_end_cb_indx_d, (int_4)1);}

  // exit gracefully
  //
  return ISIP_TRUE;
}
