// file:signal_detector/src_01/sigdp01_refine_zc.cc
//
 
// isip include files
//
#include "signal_detector_01.h"
#include "signal_detector_01_constants.h"
 
// method: refine endpoints using zerocrossing information
//
// arguments:none
// 
// return:
//  a logical_1 value indicating whether a set of valid endpoints 
// have  been found
//
logical_1 Signal_detector_01::get_more_refined_edpts_cc() {
  

  //initialize and define local variables
  //
  int_4 count = 0;
  int_4 index_p;
  int_4 i;

  //loop back 5 frames to check if zerocrossings increase a threshold
  //so that endpoints can be refinedend_time 
  
  for( i = 0 ;i < 5; i++){
    index_p = zc_cb_increment_cc( utt_beg_d , (int_4)-1);
    if(zc_cb_d[index_p]  >= zc_utt_thresh )
      {count++;}
  }
  
  //if number of frames with zcrate greater than the threshold is greater 
  //than 3, take the last checked frame as utterance beginning or 
  //utterance end as applicable
  if(count > 3)
    {refine_utt_beg_d = utt_beg_d - 5;}
  else
    {refine_utt_beg_d = utt_beg_d;}
  
  count = 0 ;
  for( i = 0 ;i < 5 ; i++){
      index_p = zc_cb_increment_cc( utt_end_d, (int_4)1);
      if(zc_cb_d[index_p]  >= zc_utt_thresh)
	{count++;}
    }
 
  if(count > 3)
    {refine_utt_end_d = utt_end_d + 2;}
  else
    {refine_utt_end_d = utt_end_d;}
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
