// file:signal_detector/src_01/sigdp01_sm_0.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "signal_detector_01.h"
#include "signal_detector_01_constants.h"

// method: sm_reset_cc
//
// arguments: none
//
// return:
//  a logical_1 value indicating the status
//
// this method resets the state machine to the "noise" state
//
logical_1 Signal_detector_01::sm_reset_cc() {

  // set to a noise state
  //
  states_d[0] = SIGD_STATE_NOIS;
  states_d[1] = SIGD_STATE_NOIS;
  states_d[2] = SIGD_STATE_NOIS;

  // clear the durations
  //
  memset(durations_d, (int_4)0, SIGD_NSTATES*sizeof(int_4));

  // exit gracefully
  //
  return ISIP_TRUE;
}
