// file: signal_detector/src_base/signal_detector_base.h
//
// this file defines the signal_detector class
//

// make sure definitions are only made once
//
#ifndef __ISIP_SIGNAL_DETECTOR_BASE
#define __ISIP_SIGNAL_DETECTOR_BASE

// system include files
//
#include <stdio.h>

// isip include files
//
#include "../integral.h"

// Signal_detector_base: a class that is used to find the start/stop times
//	of signals in data streams
//
class Signal_detector_base {

  //---------------------------------------------------------------------------
  //
  // public methods
  //
  //---------------------------------------------------------------------------
public:

  // constructors/destructors
  //
  Signal_detector_base();
  virtual ~Signal_detector_base();

  // required methods
  //
  virtual char_1* name_cc();
  virtual logical_1 debug_cc(FILE* fp, char_1* message);
  virtual int_4 get_nbytes_to_read_cc();

  // io methods
  //
  virtual logical_1 load_parameters_cc(char_1* parameter_file);
  virtual logical_1 print_parameters_cc(char_1* output_file);
  
  // initialization methods
  //
  virtual logical_1 init_cc() ;
  virtual logical_1 flush_cc();
  virtual logical_1 reset_cc();
  
  // computational methods
  //
  virtual logical_1 process_cc(void* signal);
  
  // status methods
  //
  virtual logical_1 get_endpoints_cc(float_4& t1, float_4& t2);
  
  //---------------------------------------------------------------------------
  //
  // private methods
  //
  //---------------------------------------------------------------------------
private:
  
  // general methods
  //
  
  //
  // end of class
};

//
// end of include file
#endif

