// file: project/integrate/src_main/sigd_load_0.cc
//

// isip include files
//
#include "../signal_detector.h"
#include "../signal_detector_constants.h"
#include "../src_00/signal_detector_00.h"
#include "../src_01/signal_detector_01.h"
#include "../src_base/signal_detector_base.h"

#include"../integral.h"


// method: load_parameters_cc
//
// arguments:
//  char_1* param_file_p: algorithm parameter filename
//
// return:
//  a logical_1 value indicating status
//
// this method loads algorithm parameters
//
logical_1 Signal_detector::load_parameters_cc(char_1* param_file_p) {

  // get implementation name from parameter file
  //
  if (get_implementation_name_cc(param_file_p) == ISIP_FALSE) {
    error_handler_cc("load_parameters_cc",
		     "error reading implementation name");
  }

  // create an object
  //
  if (create_object_from_name_cc(implementation_name_d) == ISIP_FALSE) {
    error_handler_cc("get_implementation_name_cc",
		     "unknown implementation name");
    return ISIP_FALSE;
  }

  // read the algorithm-specific parameters
  //
  if (sigd_d->load_parameters_cc(param_file_p) == ISIP_FALSE) {
    error_handler_cc("get_implementation_name_cc",
		     "error loading algorithm parameters");
    return ISIP_FALSE;
  }

  // set the initialization flag
  //
  init_d = ISIP_TRUE;

  // exit gracefully
  //
  return ISIP_TRUE;
}









