// file: signal_detector/src_main/sigdp_cofn_0.cc
//

// isip include files
//
#include "../integral_constants.h"

// local include files
//
#include "../signal_detector.h"
#include "../src_00/signal_detector_00.h"
#include "../src_00/signal_detector_00_constants.h"
#include "../src_01/signal_detector_01.h"
#include "../src_01/signal_detector_01_constants.h"


// method: create_object_from_name_cc
//
// arguments:
//  float_4 imp_p: (input) a number containing the implementation name
//
// return: a logical_1 value indicating status
//
logical_1 Signal_detector::create_object_from_name_cc(char_1* imp_p) {
   
  // create prototype objects
  //
  Signal_detector_00 sigd00;
  Signal_detector_01 sigd01;

  // find the proper algorithm
  //
  if (strcmp((char*)imp_p, (char*)sigd00.name_cc()) == 0)
    {sigd_d = new Signal_detector_00;}
  else if (strcmp((char*)imp_p, (char*)sigd01.name_cc()) == 0)
    {sigd_d = new Signal_detector_01;}
  else {return ISIP_FALSE;}

  // exit gracefully
  //
  return ISIP_TRUE;
}




 
