// file: signal_detector/src_main/sigdp_get_0.cc
//

// isip include files
//
#include "../integral_constants.h"
#include "../signal_detector.h"
#include "../signal_detector_constants.h"

// method: get_implementation_name_cc
//
// arguments:
//  char_1* param_file_p: (input) parameter file name
//
// return:
//  a logical_1 value indicating status
//
logical_1 Signal_detector::get_implementation_name_cc(char_1* param_file_p) {
  
  // declare local variables
  //
  char_1 line_buf[SIGD_MAX_STRING_LENGTH];
  logical_1 flag_whitespace;

  // open a file - read only
  //
  FILE* fp = fopen((char*)param_file_p, "r");
  if (fp == NULL)
    {error_handler_cc("get_implementation_cc", "can't open input file");}

  // loop until the first non-comment line is found
  //
  if(fgets((char*)line_buf, SIGD_MAX_STRING_LENGTH-1, fp) != NULL)   {

    // check for whitespace or a comment
    // 
    if ((line_buf[0] == SIGD_COMMENT_CHAR) ||
        (string_length_cc(line_buf) == (int_4)0)) {
      flag_whitespace = ISIP_TRUE;
    }
    else
      {flag_whitespace = ISIP_FALSE;}
    
    // parse the line
    //
    if (flag_whitespace == ISIP_FALSE) {
      sscanf((char*)line_buf,"%*s%*s%s", line_buf);

      // save the implementation name
      //
      implementation_name_d = new char_1[string_length_cc(line_buf)];
      strcpy((char*)implementation_name_d,(char*)line_buf);

    }
  }
  
  // exit gracefully
  //
  if (implementation_name_d == (char_1*)NULL)
    {return ISIP_FALSE;}
  return ISIP_TRUE;
}
